/* -------------------------------------------------------------
   Retorna o Device ID  do microcontrolador           26/08/2020

   Le a memoria de configuracao e extrai do campo DEVICE ID o
   codigo que identifica o microcontrolador montado no circuito
   programador.

    0x7E - PIC12F675
    0x82 - PIC16F627A
    0x83 - PIC16F628A
    0x88 - PIC16F648A
    0x8C - PIC16F688

*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <fcntl.h>
#include <errno.h>
#include <termios.h>
#include <unistd.h>

unsigned int getChipId(void) {

  extern int  serial_port;               /* terminal file handler */
  extern char read_buf[64];              /* input buffer for programmer response */
  extern char main_buffer[4096];         /* input buffer to hold lot of data */

    #define _devOffset 12
    char facke[2] = {'1','\r'};
    unsigned int chip[2];
    int i;

    memset(&read_buf, '\0', sizeof(read_buf));
    memset(&main_buffer, '\0', sizeof(main_buffer));
    write(serial_port, facke, 2);       // obtem memoria de configuracao
    read(serial_port, &main_buffer, sizeof(read_buf));

    for (i=0; i<2; i++) {
       chip[i] = (main_buffer[_devOffset+i] & 0x000000FF);
    }

    return (((chip[0]<<8) | chip[1] ) << 3) >> 8;

}






