/*
-------------------------------------------------------------------
Retorna valor de uma opcao da linha de comando           28/08/2020

Retorna a proxima opcao se encontra na frente de uma opcao da linha
de comando.

Exemplo: Suponhamos que na linha de comando temos:
         ./sppp /dev/ttyUSB0 -m pic16f628a -wp -f piscaled.hex

         e quisermos obter o nome do arquivo que esta apos a opcao
         -f, chamamos a funcao do modo abaixo:

         char* filename[] = getOpt("-f", argc, argv);

-------------------------------------------------------------------
 */
#include <string.h>
char * getOpt(char* opt, int argc, char* argv[]) {
   int ix = 0;
    while(ix < argc ) {
     if( strcmp(argv[ix], opt) == 0 ) {
       ix++;
       return argv[ix];
     }
     ix++;
   }
   return NULL;
}
